#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

vector<int> p;
vector<ll> t, a, h;

struct node;
typedef node *nodeptr;

mt19937 rng(0);

struct node {
    ll x;
    int v, sub;
    int y = rng();
    ll total;

    int sz = 1;
    nodeptr l = nullptr, r = nullptr;

    node(int v) : x(h[v]), v(v), sub(a[v]), total(a[v]) {}
};

int _sz(nodeptr root) {
    return root ? root->sz : 0;
}

ll _total(nodeptr root) {
    return root ? root->total : 0ll;
}

nodeptr recalc(nodeptr root) {
    if (!root) return nullptr;
    root->total = _total(root->l) + _total(root->r) + root->sub;
    root->sz = _sz(root->l) + _sz(root->r) + 1;
    return root;
}

pair<nodeptr, nodeptr> split(nodeptr root, ll x) {
    if (!root) return {nullptr, nullptr};
    if (root->x <= x) {
        auto [l, r] = split(root->r, x);
        root->r = l;
        return {recalc(root), r};
    } else {
        auto [l, r] = split(root->l, x);
        root->l = r;
        return {l, recalc(root)};
    };
}

nodeptr merge(nodeptr l, nodeptr r) {
    if (!l) return r;
    if (!r) return l;
    if (l->y < r->y) {
        l->r = merge(l->r, r);
        return recalc(l);
    } else {
        r->l = merge(l, r->l);
        return recalc(r);
    }
}

nodeptr cut(nodeptr root) {
    root->l = root->r = nullptr;
    return recalc(root);
}

void unite_rec(nodeptr &target, nodeptr source) {
    if (!source) return;
    unite_rec(target, source->l);
    unite_rec(target, source->r);
    auto root = cut(source);
    auto [l, r] = split(target, root->x);
    target = merge(merge(l, root), r);
}

nodeptr unite(nodeptr t1, nodeptr t2) {
    if (_sz(t1) < _sz(t2)) swap(t1, t2);
    unite_rec(t1, t2);
    return t1;
}

vector<vector<int>> g;
vector<int> order;
vector<nodeptr> reach;

void dfs(int v) {
    order.push_back(v);
    for (int u : g[v]) {
        h[u] = h[v] + t[u];
        dfs(u);
    }
}

#define all(c) c.begin(), c.end()

int main() {

    in(int, n)
    in(ll, T)
    p.assign(n, 0), t.assign(n, 0), a.resize(n);
    for (int i = 1; i < n; i++) cin >> p[i];
    for (int i = 1; i < n; i++) cin >> t[i];
    cin >> a;

    h.assign(n, 0);
    g.resize(n);
    for (int i = 1; i < n; i++) {
        g[--p[i]].push_back(i);
    }
    dfs(0);

    reach.assign(n, nullptr);
    reverse(all(order));
    int ans = -1;
    ll total = 0;
    for (int v : order) {
        reach[v] = new node(v);
        for (int u : g[v]) {
            reach[v] = unite(reach[v], reach[u]);
        }
        reach[v] = split(reach[v], h[v] + T).first;
        ll res = _total(reach[v]) + _sz(reach[v]);
        if (res > total || res == total && v < ans) {
            ans = v, total = res;
        }
    }

    cout << ans + 1 << ' ' << total << '\n';

}